<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.13"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Izg project: student/gpu.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Izg project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.13 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_df997ef5cbe81af8266600b381d65502.html">student</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">gpu.c File Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>This file contains implementation of software <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> HW.  
<a href="#details">More...</a></p>
<div class="textblock"><code>#include &lt;assert.h&gt;</code><br />
<code>#include &lt;string.h&gt;</code><br />
<code>#include &lt;stdio.h&gt;</code><br />
<code>#include &lt;<a class="el" href="gpu_8h_source.html">student/gpu.h</a>&gt;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Functions</h2></td></tr>
<tr class="memitem:a743153f4514ec830ce3f616efd2f5da1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a743153f4514ec830ce3f616efd2f5da1">gpu_initVertexPullerHead</a> (<a class="el" href="structGPUVertexPullerHead.html">GPUVertexPullerHead</a> *const head)</td></tr>
<tr class="memdesc:a743153f4514ec830ce3f616efd2f5da1"><td class="mdescLeft">&#160;</td><td class="mdescRight">This functions inits vertex puller head.  <a href="#a743153f4514ec830ce3f616efd2f5da1">More...</a><br /></td></tr>
<tr class="separator:a743153f4514ec830ce3f616efd2f5da1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a71e7f8aeac76077e9671d902dbd83c99"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a71e7f8aeac76077e9671d902dbd83c99">gpu_initIndices</a> (<a class="el" href="structGPUIndices.html">GPUIndices</a> *const i)</td></tr>
<tr class="memdesc:a71e7f8aeac76077e9671d902dbd83c99"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits indices.  <a href="#a71e7f8aeac76077e9671d902dbd83c99">More...</a><br /></td></tr>
<tr class="separator:a71e7f8aeac76077e9671d902dbd83c99"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afa69014d4262ae24b28654039ac7c3a4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#afa69014d4262ae24b28654039ac7c3a4">gpu_initVertexPuller</a> (<a class="el" href="structGPUVertexPuller.html">GPUVertexPuller</a> *const puller)</td></tr>
<tr class="memdesc:afa69014d4262ae24b28654039ac7c3a4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits vertex puller.  <a href="#afa69014d4262ae24b28654039ac7c3a4">More...</a><br /></td></tr>
<tr class="separator:afa69014d4262ae24b28654039ac7c3a4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a04a53cfe9644242b16eea893e9fc21e1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a04a53cfe9644242b16eea893e9fc21e1">gpu_activatePuller</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="student_2fwd_8h.html#a23828e2281a794e193ebaf0df3e1f17c">VertexPullerID</a> id)</td></tr>
<tr class="memdesc:a04a53cfe9644242b16eea893e9fc21e1"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function activates selected vertex puller.  <a href="#a04a53cfe9644242b16eea893e9fc21e1">More...</a><br /></td></tr>
<tr class="separator:a04a53cfe9644242b16eea893e9fc21e1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:abdc726ee99b14d504cac283156d95cc7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#abdc726ee99b14d504cac283156d95cc7">gpu_deactivatePuller</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu)</td></tr>
<tr class="memdesc:abdc726ee99b14d504cac283156d95cc7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function deactivates vertex puller.  <a href="#abdc726ee99b14d504cac283156d95cc7">More...</a><br /></td></tr>
<tr class="separator:abdc726ee99b14d504cac283156d95cc7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a923923cf0856f8526ecf90a07b303b6e"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a923923cf0856f8526ecf90a07b303b6e">gpu_isPuller</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu, <a class="el" href="student_2fwd_8h.html#a23828e2281a794e193ebaf0df3e1f17c">VertexPullerID</a> id)</td></tr>
<tr class="memdesc:a923923cf0856f8526ecf90a07b303b6e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function check if id points to valid vertex puller.  <a href="#a923923cf0856f8526ecf90a07b303b6e">More...</a><br /></td></tr>
<tr class="separator:a923923cf0856f8526ecf90a07b303b6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac7df8a38b608fcc9c3e3862fe57dbd2e"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structGPUVertexPuller.html">GPUVertexPuller</a> const  *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ac7df8a38b608fcc9c3e3862fe57dbd2e">gpu_getActivePuller</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu)</td></tr>
<tr class="memdesc:ac7df8a38b608fcc9c3e3862fe57dbd2e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns pointer to active vertex puller.  <a href="#ac7df8a38b608fcc9c3e3862fe57dbd2e">More...</a><br /></td></tr>
<tr class="separator:ac7df8a38b608fcc9c3e3862fe57dbd2e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2cc8bc8399b7f12110f3afa922b1c35f"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a2cc8bc8399b7f12110f3afa922b1c35f">gpu_initBuffer</a> (<a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const b)</td></tr>
<tr class="memdesc:a2cc8bc8399b7f12110f3afa922b1c35f"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> buffer.  <a href="#a2cc8bc8399b7f12110f3afa922b1c35f">More...</a><br /></td></tr>
<tr class="separator:a2cc8bc8399b7f12110f3afa922b1c35f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1f9b6e972b0a7d864c2ed519e87f62e9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a1f9b6e972b0a7d864c2ed519e87f62e9">gpu_isBuffer</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu, <a class="el" href="student_2fwd_8h.html#a60a12bf4868ebe47cc571ce96a03f99c">BufferID</a> id)</td></tr>
<tr class="memdesc:a1f9b6e972b0a7d864c2ed519e87f62e9"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function check if id points to valid buffer.  <a href="#a1f9b6e972b0a7d864c2ed519e87f62e9">More...</a><br /></td></tr>
<tr class="separator:a1f9b6e972b0a7d864c2ed519e87f62e9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8dc166840aaca2b29d6fc2e31afca9b"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structGPUBuffer.html">GPUBuffer</a> const  *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ac8dc166840aaca2b29d6fc2e31afca9b">gpu_getBuffer</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu, <a class="el" href="student_2fwd_8h.html#a60a12bf4868ebe47cc571ce96a03f99c">BufferID</a> id)</td></tr>
<tr class="memdesc:ac8dc166840aaca2b29d6fc2e31afca9b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns pointer to buffer.  <a href="#ac8dc166840aaca2b29d6fc2e31afca9b">More...</a><br /></td></tr>
<tr class="separator:ac8dc166840aaca2b29d6fc2e31afca9b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac6d9877988fdbccfb295181dd04413bf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ac6d9877988fdbccfb295181dd04413bf">gpu_freeBuffers</a> (<a class="el" href="structGPUBuffers.html">GPUBuffers</a> *const b)</td></tr>
<tr class="memdesc:ac6d9877988fdbccfb295181dd04413bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees all gpu buffers.  <a href="#ac6d9877988fdbccfb295181dd04413bf">More...</a><br /></td></tr>
<tr class="separator:ac6d9877988fdbccfb295181dd04413bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3053c3bd95f28fccf7b0b02404dac78e"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a3053c3bd95f28fccf7b0b02404dac78e">gpu_freeBuffer</a> (<a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const b)</td></tr>
<tr class="memdesc:a3053c3bd95f28fccf7b0b02404dac78e"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees the buffer.  <a href="#a3053c3bd95f28fccf7b0b02404dac78e">More...</a><br /></td></tr>
<tr class="separator:a3053c3bd95f28fccf7b0b02404dac78e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1f98a1992bfd78dab9ffbb6bb3d2a62"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#af1f98a1992bfd78dab9ffbb6bb3d2a62">gpu_bufferData</a> (<a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const b, uint64_t size, void *data)</td></tr>
<tr class="memdesc:af1f98a1992bfd78dab9ffbb6bb3d2a62"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function allocates and uploads data to buffer.  <a href="#af1f98a1992bfd78dab9ffbb6bb3d2a62">More...</a><br /></td></tr>
<tr class="separator:af1f98a1992bfd78dab9ffbb6bb3d2a62"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab4e449030a8bb8cb38d14eb0dfdddd5b"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ab4e449030a8bb8cb38d14eb0dfdddd5b">gpu_initBuffers</a> (<a class="el" href="structGPUBuffers.html">GPUBuffers</a> *const b)</td></tr>
<tr class="memdesc:ab4e449030a8bb8cb38d14eb0dfdddd5b"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> buffers.  <a href="#ab4e449030a8bb8cb38d14eb0dfdddd5b">More...</a><br /></td></tr>
<tr class="separator:ab4e449030a8bb8cb38d14eb0dfdddd5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b3efebca2782e2e6a90b27ba454d8c0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a7b3efebca2782e2e6a90b27ba454d8c0">gpu_initVertexPullers</a> (<a class="el" href="structGPUVertexPullers.html">GPUVertexPullers</a> *const v)</td></tr>
<tr class="memdesc:a7b3efebca2782e2e6a90b27ba454d8c0"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function init vertex pullers.  <a href="#a7b3efebca2782e2e6a90b27ba454d8c0">More...</a><br /></td></tr>
<tr class="separator:a7b3efebca2782e2e6a90b27ba454d8c0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad33a812fc890e6b7df9da1833aeb50e6"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ad33a812fc890e6b7df9da1833aeb50e6">gpu_freeVertexPullers</a> (<a class="el" href="structGPUVertexPullers.html">GPUVertexPullers</a> *const v)</td></tr>
<tr class="memdesc:ad33a812fc890e6b7df9da1833aeb50e6"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function free all vertex pullers.  <a href="#ad33a812fc890e6b7df9da1833aeb50e6">More...</a><br /></td></tr>
<tr class="separator:ad33a812fc890e6b7df9da1833aeb50e6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a8883d919f7b8f9d6c352fa2603a26884"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a8883d919f7b8f9d6c352fa2603a26884">gpu_initUniform</a> (<a class="el" href="structGPUUniform.html">GPUUniform</a> *const u)</td></tr>
<tr class="memdesc:a8883d919f7b8f9d6c352fa2603a26884"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits one uniform variable.  <a href="#a8883d919f7b8f9d6c352fa2603a26884">More...</a><br /></td></tr>
<tr class="separator:a8883d919f7b8f9d6c352fa2603a26884"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2156449a1db6f93b0853903879f8ff98"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a2156449a1db6f93b0853903879f8ff98">gpu_initUniforms</a> (<a class="el" href="structGPUUniforms.html">GPUUniforms</a> *const u)</td></tr>
<tr class="memdesc:a2156449a1db6f93b0853903879f8ff98"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits uniform variables.  <a href="#a2156449a1db6f93b0853903879f8ff98">More...</a><br /></td></tr>
<tr class="separator:a2156449a1db6f93b0853903879f8ff98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a53c57ff6adea9b0a0cd4e743bfbf4cd4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a53c57ff6adea9b0a0cd4e743bfbf4cd4">gpu_initProgram</a> (<a class="el" href="structGPUProgram.html">GPUProgram</a> *const p)</td></tr>
<tr class="memdesc:a53c57ff6adea9b0a0cd4e743bfbf4cd4"><td class="mdescLeft">&#160;</td><td class="mdescRight">This functions inits shader program.  <a href="#a53c57ff6adea9b0a0cd4e743bfbf4cd4">More...</a><br /></td></tr>
<tr class="separator:a53c57ff6adea9b0a0cd4e743bfbf4cd4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a09db2e86ac63470943d03b3165896209"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a09db2e86ac63470943d03b3165896209">gpu_initPrograms</a> (<a class="el" href="structGPUPrograms.html">GPUPrograms</a> *const p)</td></tr>
<tr class="memdesc:a09db2e86ac63470943d03b3165896209"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits programs.  <a href="#a09db2e86ac63470943d03b3165896209">More...</a><br /></td></tr>
<tr class="separator:a09db2e86ac63470943d03b3165896209"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13c7fd40b75c34ec69e3aa70ffef6eed"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a13c7fd40b75c34ec69e3aa70ffef6eed">gpu_freePrograms</a> (<a class="el" href="structGPUPrograms.html">GPUPrograms</a> *const p)</td></tr>
<tr class="memdesc:a13c7fd40b75c34ec69e3aa70ffef6eed"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees all gpu programs.  <a href="#a13c7fd40b75c34ec69e3aa70ffef6eed">More...</a><br /></td></tr>
<tr class="separator:a13c7fd40b75c34ec69e3aa70ffef6eed"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a881e0af4b1f00a29cd7ab53453394c34"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a881e0af4b1f00a29cd7ab53453394c34">gpu_activateProgram</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a> id)</td></tr>
<tr class="memdesc:a881e0af4b1f00a29cd7ab53453394c34"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function activates selected program.  <a href="#a881e0af4b1f00a29cd7ab53453394c34">More...</a><br /></td></tr>
<tr class="separator:a881e0af4b1f00a29cd7ab53453394c34"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5a2bcec1b575f2adebb048d837bc6fb1"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a5a2bcec1b575f2adebb048d837bc6fb1">gpu_isProgram</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu, <a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a> id)</td></tr>
<tr class="memdesc:a5a2bcec1b575f2adebb048d837bc6fb1"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function check if id points to valid program.  <a href="#a5a2bcec1b575f2adebb048d837bc6fb1">More...</a><br /></td></tr>
<tr class="separator:a5a2bcec1b575f2adebb048d837bc6fb1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad3b191032ebdd19d6d6903eecc80e0a7"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structGPUProgram.html">GPUProgram</a> const  *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ad3b191032ebdd19d6d6903eecc80e0a7">gpu_getActiveProgram</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu)</td></tr>
<tr class="memdesc:ad3b191032ebdd19d6d6903eecc80e0a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns pointer to active program.  <a href="#ad3b191032ebdd19d6d6903eecc80e0a7">More...</a><br /></td></tr>
<tr class="separator:ad3b191032ebdd19d6d6903eecc80e0a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a698e7eb20b79013c2218e0595c8eab01"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a698e7eb20b79013c2218e0595c8eab01">gpu_pushCommand</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a> type)</td></tr>
<tr class="memdesc:a698e7eb20b79013c2218e0595c8eab01"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pushes command to gpu's command buffer.  <a href="#a698e7eb20b79013c2218e0595c8eab01">More...</a><br /></td></tr>
<tr class="separator:a698e7eb20b79013c2218e0595c8eab01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acb2777e0388b2fdf0d8367c41bb86118"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#acb2777e0388b2fdf0d8367c41bb86118">gpu_pushCommand1</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a> type, uint64_t p0)</td></tr>
<tr class="memdesc:acb2777e0388b2fdf0d8367c41bb86118"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pushes command to gpu's command buffer.  <a href="#acb2777e0388b2fdf0d8367c41bb86118">More...</a><br /></td></tr>
<tr class="separator:acb2777e0388b2fdf0d8367c41bb86118"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a7b54b5ee430347057a82a1f0bd6b4220"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a7b54b5ee430347057a82a1f0bd6b4220">gpu_pushCommand2</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a> type, uint64_t p0, uint64_t p1)</td></tr>
<tr class="memdesc:a7b54b5ee430347057a82a1f0bd6b4220"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function pushes command to gpu's command buffer.  <a href="#a7b54b5ee430347057a82a1f0bd6b4220">More...</a><br /></td></tr>
<tr class="separator:a7b54b5ee430347057a82a1f0bd6b4220"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad7cca645cd6396c31ff39bfad247b4ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ad7cca645cd6396c31ff39bfad247b4ca">gpu_initFramebuffer</a> (<a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const f)</td></tr>
<tr class="memdesc:ad7cca645cd6396c31ff39bfad247b4ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function inits framebuffer.  <a href="#ad7cca645cd6396c31ff39bfad247b4ca">More...</a><br /></td></tr>
<tr class="separator:ad7cca645cd6396c31ff39bfad247b4ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae478e572c88385f7bb182ed58cf08849"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ae478e572c88385f7bb182ed58cf08849">gpu_allocateFramebuffer</a> (<a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const f, uint32_t width, uint32_t height)</td></tr>
<tr class="memdesc:ae478e572c88385f7bb182ed58cf08849"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function allocates framebuffer.  <a href="#ae478e572c88385f7bb182ed58cf08849">More...</a><br /></td></tr>
<tr class="separator:ae478e572c88385f7bb182ed58cf08849"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a684b99175d7317867e4655723c94348c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a684b99175d7317867e4655723c94348c">gpu_freeFramebuffer</a> (<a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const f)</td></tr>
<tr class="memdesc:a684b99175d7317867e4655723c94348c"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function frees the framebuffer.  <a href="#a684b99175d7317867e4655723c94348c">More...</a><br /></td></tr>
<tr class="separator:a684b99175d7317867e4655723c94348c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a808bed87d3c8520b4d0a8e53a0e4fcd5"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#a808bed87d3c8520b4d0a8e53a0e4fcd5">gpu_clearFramebuffer</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu)</td></tr>
<tr class="memdesc:a808bed87d3c8520b4d0a8e53a0e4fcd5"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function clears framebuffer.  <a href="#a808bed87d3c8520b4d0a8e53a0e4fcd5">More...</a><br /></td></tr>
<tr class="separator:a808bed87d3c8520b4d0a8e53a0e4fcd5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ade19e622af460c7c863a2abc99723702"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ade19e622af460c7c863a2abc99723702">gpu_finish</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu)</td></tr>
<tr class="memdesc:ade19e622af460c7c863a2abc99723702"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function executes all commands in gpu's command queue.  <a href="#ade19e622af460c7c863a2abc99723702">More...</a><br /></td></tr>
<tr class="separator:ade19e622af460c7c863a2abc99723702"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae41e3e28b2af6568269d24e91b087a50"><td class="memItemLeft" align="right" valign="top"><a class="el" href="structGPUUniform.html">GPUUniform</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#ae41e3e28b2af6568269d24e91b087a50">gpu_getUniform</a> (<a class="el" href="structGPU.html">GPU</a> *const gpu, <a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a> programId, uint32_t uniformId)</td></tr>
<tr class="memdesc:ae41e3e28b2af6568269d24e91b087a50"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function returns pointer to selected uniform.  <a href="#ae41e3e28b2af6568269d24e91b087a50">More...</a><br /></td></tr>
<tr class="separator:ae41e3e28b2af6568269d24e91b087a50"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af9007f31171596847f0b2302a180b749"><td class="memItemLeft" align="right" valign="top">uint8_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#af9007f31171596847f0b2302a180b749">gpu_floatColorToUint32</a> (float const value)</td></tr>
<tr class="memdesc:af9007f31171596847f0b2302a180b749"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function converts float [0,1] to byte [0,255].  <a href="#af9007f31171596847f0b2302a180b749">More...</a><br /></td></tr>
<tr class="separator:af9007f31171596847f0b2302a180b749"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:afe328aa124cc88b73dfa359296624119"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="gpu_8c.html#afe328aa124cc88b73dfa359296624119">gpu_checkDraw</a> (<a class="el" href="structGPU.html">GPU</a> const *const gpu, uint32_t nofVertices)</td></tr>
<tr class="memdesc:afe328aa124cc88b73dfa359296624119"><td class="mdescLeft">&#160;</td><td class="mdescRight">This function check gpu state for draw call.  <a href="#afe328aa124cc88b73dfa359296624119">More...</a><br /></td></tr>
<tr class="separator:afe328aa124cc88b73dfa359296624119"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>This file contains implementation of software <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> HW. </p>
<dl class="section author"><dt>Author</dt><dd>Tomáš Milet, <a href="#" onclick="location.href='mai'+'lto:'+'imi'+'le'+'t@f'+'it'+'.vu'+'tb'+'r.c'+'z'; return false;">imile<span style="display: none;">.nosp@m.</span>t@fi<span style="display: none;">.nosp@m.</span>t.vut<span style="display: none;">.nosp@m.</span>br.c<span style="display: none;">.nosp@m.</span>z</a> </dd></dl>
</div><h2 class="groupheader">Function Documentation</h2>
<a id="a881e0af4b1f00a29cd7ab53453394c34"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a881e0af4b1f00a29cd7ab53453394c34">&#9670;&nbsp;</a></span>gpu_activateProgram()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_activateProgram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function activates selected program. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>program id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a04a53cfe9644242b16eea893e9fc21e1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a04a53cfe9644242b16eea893e9fc21e1">&#9670;&nbsp;</a></span>gpu_activatePuller()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_activatePuller </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a23828e2281a794e193ebaf0df3e1f17c">VertexPullerID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function activates selected vertex puller. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>vertex puller id </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ae478e572c88385f7bb182ed58cf08849"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae478e572c88385f7bb182ed58cf08849">&#9670;&nbsp;</a></span>gpu_allocateFramebuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_allocateFramebuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const&#160;</td>
          <td class="paramname"><em>f</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>width</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>height</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function allocates framebuffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">f</td><td>framebuffer </td></tr>
    <tr><td class="paramname">width</td><td>width of the framebuffer </td></tr>
    <tr><td class="paramname">height</td><td>height of the framebuffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af1f98a1992bfd78dab9ffbb6bb3d2a62"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af1f98a1992bfd78dab9ffbb6bb3d2a62">&#9670;&nbsp;</a></span>gpu_bufferData()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_bufferData </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const&#160;</td>
          <td class="paramname"><em>b</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>size</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>data</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function allocates and uploads data to buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>buffer </td></tr>
    <tr><td class="paramname">size</td><td>size of new buffer </td></tr>
    <tr><td class="paramname">data</td><td>optional data pointer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="afe328aa124cc88b73dfa359296624119"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afe328aa124cc88b73dfa359296624119">&#9670;&nbsp;</a></span>gpu_checkDraw()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_checkDraw </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>nofVertices</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function check gpu state for draw call. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">nofVertices</td><td>number of vertices </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a808bed87d3c8520b4d0a8e53a0e4fcd5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a808bed87d3c8520b4d0a8e53a0e4fcd5">&#9670;&nbsp;</a></span>gpu_clearFramebuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_clearFramebuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function clears framebuffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>framebuffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="abdc726ee99b14d504cac283156d95cc7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#abdc726ee99b14d504cac283156d95cc7">&#9670;&nbsp;</a></span>gpu_deactivatePuller()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_deactivatePuller </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function deactivates vertex puller. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ade19e622af460c7c863a2abc99723702"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ade19e622af460c7c863a2abc99723702">&#9670;&nbsp;</a></span>gpu_finish()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_finish </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function executes all commands in gpu's command queue. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="af9007f31171596847f0b2302a180b749"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af9007f31171596847f0b2302a180b749">&#9670;&nbsp;</a></span>gpu_floatColorToUint32()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">uint8_t gpu_floatColorToUint32 </td>
          <td>(</td>
          <td class="paramtype">float const&#160;</td>
          <td class="paramname"><em>value</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function converts float [0,1] to byte [0,255]. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">value</td><td>float value in range [0,1]</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>byte value in range [0,255] </dd></dl>

</div>
</div>
<a id="a3053c3bd95f28fccf7b0b02404dac78e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3053c3bd95f28fccf7b0b02404dac78e">&#9670;&nbsp;</a></span>gpu_freeBuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_freeBuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees the buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>buffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ac6d9877988fdbccfb295181dd04413bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac6d9877988fdbccfb295181dd04413bf">&#9670;&nbsp;</a></span>gpu_freeBuffers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_freeBuffers </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUBuffers.html">GPUBuffers</a> *const&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees all gpu buffers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>buffers </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a684b99175d7317867e4655723c94348c"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a684b99175d7317867e4655723c94348c">&#9670;&nbsp;</a></span>gpu_freeFramebuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_freeFramebuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees the framebuffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">f</td><td>framebuffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a13c7fd40b75c34ec69e3aa70ffef6eed"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a13c7fd40b75c34ec69e3aa70ffef6eed">&#9670;&nbsp;</a></span>gpu_freePrograms()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_freePrograms </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUPrograms.html">GPUPrograms</a> *const&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function frees all gpu programs. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">p</td><td>programs </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad33a812fc890e6b7df9da1833aeb50e6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad33a812fc890e6b7df9da1833aeb50e6">&#9670;&nbsp;</a></span>gpu_freeVertexPullers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_freeVertexPullers </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUVertexPullers.html">GPUVertexPullers</a> *const&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function free all vertex pullers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">v</td><td>vertex pullers </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad3b191032ebdd19d6d6903eecc80e0a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad3b191032ebdd19d6d6903eecc80e0a7">&#9670;&nbsp;</a></span>gpu_getActiveProgram()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structGPUProgram.html">GPUProgram</a> const* gpu_getActiveProgram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns pointer to active program. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointer to active program or NULL </dd></dl>

</div>
</div>
<a id="ac7df8a38b608fcc9c3e3862fe57dbd2e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac7df8a38b608fcc9c3e3862fe57dbd2e">&#9670;&nbsp;</a></span>gpu_getActivePuller()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structGPUVertexPuller.html">GPUVertexPuller</a> const* gpu_getActivePuller </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns pointer to active vertex puller. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>vertex puller pointer </dd></dl>

</div>
</div>
<a id="ac8dc166840aaca2b29d6fc2e31afca9b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac8dc166840aaca2b29d6fc2e31afca9b">&#9670;&nbsp;</a></span>gpu_getBuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structGPUBuffer.html">GPUBuffer</a> const* gpu_getBuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a60a12bf4868ebe47cc571ce96a03f99c">BufferID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns pointer to buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>id of buffer</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>pointer to buffer </dd></dl>

</div>
</div>
<a id="ae41e3e28b2af6568269d24e91b087a50"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae41e3e28b2af6568269d24e91b087a50">&#9670;&nbsp;</a></span>gpu_getUniform()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="structGPUUniform.html">GPUUniform</a>* gpu_getUniform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a>&#160;</td>
          <td class="paramname"><em>programId</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32_t&#160;</td>
          <td class="paramname"><em>uniformId</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function returns pointer to selected uniform. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">programId</td><td>program id </td></tr>
    <tr><td class="paramname">uniformId</td><td>uniform id</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd></dd></dl>

</div>
</div>
<a id="a2cc8bc8399b7f12110f3afa922b1c35f"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2cc8bc8399b7f12110f3afa922b1c35f">&#9670;&nbsp;</a></span>gpu_initBuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initBuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUBuffer.html">GPUBuffer</a> *const&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>buffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ab4e449030a8bb8cb38d14eb0dfdddd5b"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ab4e449030a8bb8cb38d14eb0dfdddd5b">&#9670;&nbsp;</a></span>gpu_initBuffers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initBuffers </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUBuffers.html">GPUBuffers</a> *const&#160;</td>
          <td class="paramname"><em>b</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits <a class="el" href="structGPU.html" title="This struct represents GPU data. ">GPU</a> buffers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">b</td><td>biffers </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="ad7cca645cd6396c31ff39bfad247b4ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ad7cca645cd6396c31ff39bfad247b4ca">&#9670;&nbsp;</a></span>gpu_initFramebuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initFramebuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUFramebuffer.html">GPUFramebuffer</a> *const&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits framebuffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">f</td><td>framebuffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a71e7f8aeac76077e9671d902dbd83c99"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a71e7f8aeac76077e9671d902dbd83c99">&#9670;&nbsp;</a></span>gpu_initIndices()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initIndices </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUIndices.html">GPUIndices</a> *const&#160;</td>
          <td class="paramname"><em>i</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits indices. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">i</td><td>indices </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a53c57ff6adea9b0a0cd4e743bfbf4cd4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a53c57ff6adea9b0a0cd4e743bfbf4cd4">&#9670;&nbsp;</a></span>gpu_initProgram()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initProgram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUProgram.html">GPUProgram</a> *const&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This functions inits shader program. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">p</td><td>shader program </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a09db2e86ac63470943d03b3165896209"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a09db2e86ac63470943d03b3165896209">&#9670;&nbsp;</a></span>gpu_initPrograms()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initPrograms </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUPrograms.html">GPUPrograms</a> *const&#160;</td>
          <td class="paramname"><em>p</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits programs. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">p</td><td>programs </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a8883d919f7b8f9d6c352fa2603a26884"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a8883d919f7b8f9d6c352fa2603a26884">&#9670;&nbsp;</a></span>gpu_initUniform()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initUniform </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUUniform.html">GPUUniform</a> *const&#160;</td>
          <td class="paramname"><em>u</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits one uniform variable. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">u</td><td>uniform variable </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a2156449a1db6f93b0853903879f8ff98"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2156449a1db6f93b0853903879f8ff98">&#9670;&nbsp;</a></span>gpu_initUniforms()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initUniforms </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUUniforms.html">GPUUniforms</a> *const&#160;</td>
          <td class="paramname"><em>u</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits uniform variables. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">u</td><td>uniform variables </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="afa69014d4262ae24b28654039ac7c3a4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#afa69014d4262ae24b28654039ac7c3a4">&#9670;&nbsp;</a></span>gpu_initVertexPuller()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initVertexPuller </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUVertexPuller.html">GPUVertexPuller</a> *const&#160;</td>
          <td class="paramname"><em>puller</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function inits vertex puller. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">puller</td><td>puller </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a743153f4514ec830ce3f616efd2f5da1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a743153f4514ec830ce3f616efd2f5da1">&#9670;&nbsp;</a></span>gpu_initVertexPullerHead()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initVertexPullerHead </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUVertexPullerHead.html">GPUVertexPullerHead</a> *const&#160;</td>
          <td class="paramname"><em>head</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This functions inits vertex puller head. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">head</td><td>head </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7b3efebca2782e2e6a90b27ba454d8c0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b3efebca2782e2e6a90b27ba454d8c0">&#9670;&nbsp;</a></span>gpu_initVertexPullers()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_initVertexPullers </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPUVertexPullers.html">GPUVertexPullers</a> *const&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function init vertex pullers. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">v</td><td>vertex pullers </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a1f9b6e972b0a7d864c2ed519e87f62e9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a1f9b6e972b0a7d864c2ed519e87f62e9">&#9670;&nbsp;</a></span>gpu_isBuffer()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int gpu_isBuffer </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a60a12bf4868ebe47cc571ce96a03f99c">BufferID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function check if id points to valid buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>buffer id</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if id points to buffer, 0 otherwise </dd></dl>

</div>
</div>
<a id="a5a2bcec1b575f2adebb048d837bc6fb1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5a2bcec1b575f2adebb048d837bc6fb1">&#9670;&nbsp;</a></span>gpu_isProgram()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int gpu_isProgram </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a15e62786033208aec9487a51e808f81d">ProgramID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function check if id points to valid program. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>vertex puller id</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if id points to valid program, 0 otherwise </dd></dl>

</div>
</div>
<a id="a923923cf0856f8526ecf90a07b303b6e"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a923923cf0856f8526ecf90a07b303b6e">&#9670;&nbsp;</a></span>gpu_isPuller()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int gpu_isPuller </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> const *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="student_2fwd_8h.html#a23828e2281a794e193ebaf0df3e1f17c">VertexPullerID</a>&#160;</td>
          <td class="paramname"><em>id</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function check if id points to valid vertex puller. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">id</td><td>vertex puller id</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>1 if id points to valid puller, 0 otherwise </dd></dl>

</div>
</div>
<a id="a698e7eb20b79013c2218e0595c8eab01"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a698e7eb20b79013c2218e0595c8eab01">&#9670;&nbsp;</a></span>gpu_pushCommand()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_pushCommand </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a>&#160;</td>
          <td class="paramname"><em>type</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pushes command to gpu's command buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">type</td><td>command type </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="acb2777e0388b2fdf0d8367c41bb86118"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acb2777e0388b2fdf0d8367c41bb86118">&#9670;&nbsp;</a></span>gpu_pushCommand1()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_pushCommand1 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>p0</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pushes command to gpu's command buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">type</td><td>command type </td></tr>
    <tr><td class="paramname">p0</td><td>first parameter of command </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a7b54b5ee430347057a82a1f0bd6b4220"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a7b54b5ee430347057a82a1f0bd6b4220">&#9670;&nbsp;</a></span>gpu_pushCommand2()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void gpu_pushCommand2 </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structGPU.html">GPU</a> *const&#160;</td>
          <td class="paramname"><em>gpu</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="gpu_8h.html#a0e570b421c70c09be4d05c1c0ac49a02">GPUCommandType</a>&#160;</td>
          <td class="paramname"><em>type</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>p0</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint64_t&#160;</td>
          <td class="paramname"><em>p1</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>This function pushes command to gpu's command buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">gpu</td><td>gpu </td></tr>
    <tr><td class="paramname">type</td><td>command type </td></tr>
    <tr><td class="paramname">p0</td><td>first parameter of command </td></tr>
    <tr><td class="paramname">p1</td><td>second parameter of command </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Apr 23 2019 13:21:21 for Izg project by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.13
</small></address>
</body>
</html>
